#include <QObject>

#include <functional>
#include <memory>

#include "snake.h"

#include "GeneratorData.h"

namespace routing {

class GeneratorBase : public QObject {
  Q_OBJECT
public:
  using Generator = std::function<bool(snake::Transects &)>;

  explicit GeneratorBase(QObject *parent = nullptr);
  GeneratorBase(std::shared_ptr<GeneratorData> par, QObject *parent = nullptr);
  ~GeneratorBase();

  virtual QString editorQML() = 0;
  virtual QString mapVisualQML() = 0;

  virtual QString name() = 0;
  virtual QString abbreviation() = 0;

  virtual Generator get() = 0;

  virtual bool setData(std::shared_ptr<GeneratorData> par) = 0;
  virtual std::shared_ptr<GeneratorData> data() = 0;
};

} // namespace routing
