import QtQuick          2.3
import QtQuick.Controls 1.2
import QtLocation       5.3
import QtPositioning    5.3

import QGroundControl               1.0
import QGroundControl.ScreenTools   1.0
import QGroundControl.Palette       1.0
import QGroundControl.Controls      1.0
import QGroundControl.FlightMap     1.0

/// Wima Measurement Area Data visuals
Item {
    id: _root

    property var map        ///< Map control to place item in
    property var qgcView    ///< QGCView to use for popping dialogs

    property var areaItem:          object
    signal clicked(int sequenceNumber)

    property var _polygonComponent


    function _addPolygon(){
        if(!_polygonComponent){
            _polygonComponent = polygon.createObject(_root)
            map.addMapItem(_polygonComponent)
        }
    }

    function _destroyPolygon(){
        if(_polygonComponent){
            map.removeMapItem(_polygonComponent)
            _polygonComponent.destroy()
        }
    }

    Component.onCompleted: {
        _addPolygon()
    }

    Component.onDestruction:  {
        _destroyPolygon()
    }

    // Polygon component.
    Component{
        id:polygon

        MapPolygon {
            path:           object.path;
            border.color:   "black"
            color:          "gray"
            opacity:        0.25
        }
    }
}
